/* automate cellulaire */
/* reaction Belousov Zhabotinsky */
/* d'apres rapport probatoire de Eric Vallet 1995 */
/* P. Cubaud Jan. 99 */
// PC portage Processing 1/08


int DIM = 600;
int  K1 = 2;
int  K2 = 3;
int  G = 17;

int[][]C = new int[DIM][DIM];
int[][]D = new int[DIM][DIM];
int i,j,t,a,b,c;

int SommeMoore(int i, int j) {
 int im1 = (i == 0)?DIM-1:i-1;
 int ip1 = (i == DIM-1)?0:i+1;
 int jm1 = (j == 0)?DIM-1:j-1;
 int jp1 = (j == DIM-1)?0:j+1;
 int s= C[i][j];
 s+= C[im1][jm1];
 s+= C[im1][j];
 s+= C[im1][jp1];
 s+= C[i][jm1];
 s+= C[i][jp1];
 s+= C[ip1][jm1];
 s+= C[ip1][j];
 s+= C[ip1][jp1];
 return s;     
}

int NbreVoisins(int i,int j,int v) {
 int im1 = (i == 0)?DIM-1:i-1;
 int ip1 = (i == DIM-1)?0:i+1;
 int jm1 = (j == 0)?DIM-1:j-1;
 int jp1 = (j == DIM-1)?0:j+1;
 int n = 0;
 if (C[im1][jm1]==v){n++;}
 if (C[im1][j]==v){n++;}
 if (C[im1][jp1]==v){n++;}
 if (C[i][jm1]==v){n++;}
 if (C[i][jp1]==v){n++;}
 if (C[ip1][jm1]==v){n++;}
 if (C[ip1][j]==v){n++;}
 if (C[ip1][jp1]==v){n++;}
 return n;
}

void setup(){
  size(800,800);
  frameRate(10);  
 colorMode(HSB,360,100,100);
  //colorMode(RGB,100);
  for (i=0;i<DIM;i++)
   for (j=0;j<DIM;j++)
    {C[i][j]=int(50*random(0,1));}

}

void draw(){
 background(0);
 for (i=0;i<DIM;i++)
  for (j=0;j<DIM;j++){
   c= C[i][j]; 
   if (c==0){
    a=8-NbreVoisins(i,j,0);
    b=NbreVoisins(i,j,99);
    c=(int)(a/K1+b/K2);
   }
   else {
    a=8-NbreVoisins(i,j,0);
    if (a!=0) {c=(int)SommeMoore(i,j)/a;}
    c+=G;
    if (c>99) {c=0;}
   }
  D[i][j]=c;
  }
 for (i=0;i<DIM;i++)
  for (j=0;j<DIM;j++)
   {C[i][j]=D[i][j];}
 
 /*-- affichage resultat --*/
 for (i=0;i<DIM;i++)
  for (j=0;j<DIM;j++){
   color c = color(C[i][j],100,100);
   //color c = color(C[i][j],C[i][j],C[i][j]);
   set(i,j,c);
   }
}

void keyPressed(){
  noLoop();
  save("hodge"+frameCount+".png");
}